<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Discipline extends Controller_UserEnvironment {

    /** Создание дисциплины. */
    public function action_create_discipline() {
        $twig = Twig::factory('teacher/discipline/CreateDiscipline');

        $twig->User = $this->user;
        $twig->FacultiesList = Model_Faculties::load();
        $twig->SubjectsList = Model_Subjects::byFaculty($this->user['FacultyID']);
        $twig->GradesList = Model_Grades::toArray();

        $this->response->body($twig);
    }

    /** Создание курсовой. */
    public function action_create_coursework() {
        $twig = Twig::factory('teacher/discipline/CreateCoursework');

        $twig->User = $this->user;
        $twig->FacultiesList = Model_Faculties::load();
        $twig->SubjectsList = Model_Subjects::byFaculty($this->user['FacultyID']);
        $twig->GradesList = Model_Grades::toArray();

        $this->response->body($twig);
    }
    
    public function action_EditSettings() {
        $twig = Twig::factory('teacher/discipline/EditSettings');
        $id = $this->request->param('id');

        $twig->User = $this->user;
        $twig->Discipline = $this->getDisciplineInfo($id);
        $twig->SubjectsList = Model_Subjects::byFaculty($this->user['FacultyID']);
        $twig->GradesList = Model_Grades::toArray();
        
        $this->response->body($twig);
    }

    public function action_EditStructure() {
        $twig = Twig::factory('teacher/discipline/EditStructure');
        $id = $this->request->param('id');

        $twig->User = $this->user;
        $twig->Discipline = $this->getDisciplineInfo($id);
        $twig->Map = $this->GetMapInfo(Model_Map::getMapForDiscipline($id));
        
        $this->response->body($twig);
    }
    
    public function action_EditGroups() {
        $twig = Twig::factory('teacher/discipline/EditGroups');
        $id = $this->request->param('id');

        $twig->User = $this->user;
        $twig->Discipline = $this->getDisciplineInfo($id);
        $twig->GroupsForDiscipline = Model_Discipline::load($id)->getGroups();
        $twig->Groups = Model_Faculty::with($twig->Discipline['FacultyID'])
            ->getGroups($twig->Discipline['GradeID']);
        
        $this->response->body($twig);
    }
    
    public function action_EditStudents() {
        $twig = Twig::factory('teacher/discipline/EditStudents');
        $id = $this->request->param('id');

        $twig->User = $this->user;
        $twig->Discipline = $this->getDisciplineInfo($id);
        $twig->GradesList = Model_Grades::toArray();
        $twig->GroupsList = Model_Faculty::with($twig->Discipline['FacultyID'])
            ->getGroups($twig->Discipline['GradeID']);

        $students = Model_Students::ofDiscipline($id);
        $stdHandled = array();
        $attachStdHandled = array();
        $groupID = 0; 
        $i = 0; 
        $k = 0;
        $n = 0;
        $j = 0;
        foreach($students as $row) {
            if ($row['AttachType'] == 'attach'){
                if ($row['GroupID'] != $groupID) {
                    $groupID = $row['GroupID'];
                    $k++;
                    $n = 0;
                    $attachStdHandled[$k]['GroupID'] = $row['GroupID'];
                    $attachStdHandled[$k]['GradeID'] = $row['GradeID'];
                    $attachStdHandled[$k]['GradeNum'] = $row['GradeNum'];
                    $attachStdHandled[$k]['GroupNum'] = $row['GroupNum'];
                    $attachStdHandled[$k]['Degree'] = Model_Grades::getDegreeTitle($row['Degree']);
                }
                $n++;
                $attachStdHandled[$k]['students'][$n]['ID'] = $row['ID'];
                $attachStdHandled[$k]['students'][$n]['LastName'] = $row['LastName'];
                $attachStdHandled[$k]['students'][$n]['FirstName'] = $row['FirstName'];
                $attachStdHandled[$k]['students'][$n]['SecondName'] = $row['SecondName'];
                $attachStdHandled[$k]['students'][$n]['AttachType'] = $row['AttachType'];

                // $k++;
                // $attachStdHandled['StdCount'] += 1;
                // $attachStdHandled[$k]['StudentID'] = $row['StudentID'];
                // $attachStdHandled[$k]['LastName'] = $row['LastName'];
                // $attachStdHandled[$k]['FirstName'] = $row['FirstName'];
                // $attachStdHandled[$k]['SecondName'] = $row['SecondName'];
                // $attachStdHandled[$k]['StudentID'] = $row['StudentID'];
                // $attachStdHandled[$k]['GroupID'] = $row['GroupID'];
                // $attachStdHandled[$k]['GradeID'] = $row['GradeID'];
                // $attachStdHandled[$k]['GradeNum'] = $row['GradeNum'];
                // $attachStdHandled[$k]['GroupNum'] = $row['GroupNum'];
                // $attachStdHandled[$k]['Degree'] = $row['Degree'];
            }
            else
            {
                if ($row['GroupID'] != $groupID) {
                    $groupID = $row['GroupID'];
                    $i++;
                    $j = 0;
                    $stdHandled[$i]['GroupID'] = $row['GroupID'];
                    $stdHandled[$i]['GradeID'] = $row['GradeID'];
                    $stdHandled[$i]['GradeNum'] = $row['GradeNum'];
                    $stdHandled[$i]['GroupNum'] = $row['GroupNum'];
                    $stdHandled[$i]['Degree'] = Model_Grades::getDegreeTitle($row['Degree']);
                }
                $j++;
                $stdHandled[$i]['students'][$j]['ID'] = $row['ID'];
                $stdHandled[$i]['students'][$j]['LastName'] = $row['LastName'];
                $stdHandled[$i]['students'][$j]['FirstName'] = $row['FirstName'];
                $stdHandled[$i]['students'][$j]['SecondName'] = $row['SecondName'];
                $stdHandled[$i]['students'][$j]['AttachType'] = $row['AttachType'];
            }

        }
        $twig->Groups = $stdHandled;
        $twig->GroupsAttached = $attachStdHandled;

        $this->response->body($twig);
    }
    
    public function action_EditTeachers() {
        $twig = Twig::factory('teacher/discipline/EditTeachers');
        $id = $this->request->param('id');

        $twig->User = $this->user;
        $twig->Discipline = $this->getDisciplineInfo($id);
        $twig->BindTeachersList = Model_Teachers::getNamesForDiscipline($id);
        $twig->FacultiesList = Model_Faculties::load();
        $twig->Departments = Model_Departments::byFaculty($this->user['FacultyID']);
        $twig->Author = Model_Account::getPersonalInfo($twig->Discipline['AuthorID']);

        $this->response->body($twig);
    }
    
    private function GetMapInfo($map) {
        $mapHandled = array();

        $maxRate = 0; $i = 0; $module = 0;
        foreach($map as $row)
        {
            if ($row['ModuleType'] == 'extra')
                continue;
            if($row['ModuleID'] != $module)
            {
                $i++;
                $module = $row['ModuleID'];
                $mapHandled[$i]['ModuleID'] = $row['ModuleID'];
                $mapHandled[$i]['ModuleType'] = $row['ModuleType'];
                if ($row['ModuleType'] == 'bonus')
                    $mapHandled['isSetBonus'] = true;
                $mapHandled[$i]['CurrentControl'] = 0;
                $mapHandled[$i]['LandmarkControl'] = 0;
            }
            if(!isset($mapHandled[$i]['SubmodulesCount']))
            {
                $mapHandled[$i]['SubmodulesCount'] = 0;
                $mapHandled[$i]['MaxRate'] = 0;
            }
            $mapHandled[$i]['IsExam'] = $row['IsExam'];
            $j = $mapHandled[$i]['SubmodulesCount'] += 1;
            $mapHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
            $mapHandled[$i]['ModuleTitle'] = $row['ModuleName'];
            $mapHandled[$i][$j]['SubmoduleID'] = $row['SubmoduleID'];
            $mapHandled[$i][$j]['Title'] = $row['SubmoduleName'];
            $mapHandled[$i][$j]['Description'] = $row['SubmoduleDescription'];
            $mapHandled[$i][$j]['SubmoduleControl'] = $row['SubmoduleType'];
            $mapHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
            $maxRate += $row['MaxRate'];
            if ($row['SubmoduleType'] == 'CurrentControl')
                 $mapHandled[$i]['CurrentControl'] += (int) $row['MaxRate'];
            if ($row['SubmoduleType'] == 'LandmarkControl')
                 $mapHandled[$i]['LandmarkControl'] += (int) $row['MaxRate'];
        }
        $mapHandled['ModulesCount'] = $i;
        $mapHandled['MaxRate'] = (int) $maxRate; 
        if ($mapHandled['isSetBonus'] == true)
            $mapHandled['MaxRate'] = $mapHandled['MaxRate'] - 10;

        return $mapHandled;
    }

    public function getDisciplineInfo($id) {
        $discipline = Model_Discipline::load($id);
        if ($this->user['TeacherID'] != $discipline->authorID)
            throw HTTP_Exception::factory(403, "Недостаточно прав для редактирования.");

        $data = $discipline->toArray();
        $semester = Model_Semesters::getInfo($discipline->semesterID);
        $data['SemesterNum']   = $semester['SemesterNum'] == 1 ? 'Осенний' : 'Весенний';
        $data['SemesterYear']  = $semester['SemesterYear'];
        $data['LectureHours']  = $discipline->lectures;
        $data['PracticeHours'] = $discipline->practice;
        $data['LabHours']      = $discipline->labs;
        $data['Teachers']      = self::getTeachersList($discipline->ID);

        return $data;
    }

    private static function getTeachersList($discipline) {
        $teachers = Model_Teachers::getNamesForDiscipline($discipline);

        $list = array();
        foreach ($teachers as $row) {
            $name = $row['LastName'] . ' ' . $row['FirstName'];
            if (!empty($row['SecondName']))
                $name .= ' ' . $row['SecondName'];
            $list[] = $name;
        }

        return implode(', ', $list);
    }
}
            